/* 

 */


/*
 * armazena arrays de vertices, faces -> vertices, vertices -> vertices (arestas)
*/
function DataToMesh() 
{
    this.vertex = new Array();
    this.faces_vertex= new Array();
    this.vertex_vertex_edge; //edges - edge array apontando para o index do edge!
}

//recebe arrays e converte para half-edge
function MeshData(file)
{
    this.vertexNumber = 0;
    this.faceNumber   = 0;
    
    this.vertices = new Array();
    this.faces  = new Array();
    this.edges  = new Array();
    
    var dataToMesh = new DataToMesh();
    var m = new MeshLoader();
    m.loadFile(file,dataToMesh);
    
    this.vertexNumber = dataToMesh.vertex.length;
    this.faceNumber   = dataToMesh.faces_vertex.length;
    var i;
    
    dataToMesh.vertex_vertex_edge = new Array(this.vertexNumber);//[v1][v2]->edge
    for(i =0; i < this.vertexNumber; i++)
    {
        dataToMesh.vertex_vertex_edge[i] = new Array();
        var v = new Vertex(dataToMesh.vertex[i][0],dataToMesh.vertex[i][1],dataToMesh.vertex[i][2]);
        v.index = i;
        this.vertices.push(v);
    }
    
    
    
    dataToMesh.vertex = null;
    
    //cria as edges
    for(i = 0; i < this.faceNumber; i++)
    {
        var v1Idx = dataToMesh.faces_vertex[i][0];
        var v2Idx = dataToMesh.faces_vertex[i][1];
        var v3Idx = dataToMesh.faces_vertex[i][2];
        this.vertices[v1Idx].faces.push(i);
        this.vertices[v2Idx].faces.push(i);
        this.vertices[v3Idx].faces.push(i);
        
        var edge1 = new Edge(i, dataToMesh.faces_vertex[i][1]);
        edge1.index = this.edges.length;
        edge1.nextHalfEdge = edge1.index +1;
        edge1.originVertex = v1Idx;
        this.edges.push(edge1);
        if(this.vertices[v1Idx] == null)
            this.vertices[v1Idx].setOutEdge(this.edges.length-1);
        
        var f = new Face(edge1.index);
        f.index = i;
        this.faces.push(f);
        
        
        var edge2 = new Edge(i, dataToMesh.faces_vertex[i][2]);
        edge2.index = this.edges.length;
        edge2.nextHalfEdge = edge2.index+1;//proxima edge
        edge2.originVertex = v2Idx;
        this.edges.push(edge2);
        if(this.vertices[v2Idx] == null)
            this.vertices[v2Idx].setOutEdge(this.edges.length-1);
        
        
        var edge3 = new Edge(i, dataToMesh.faces_vertex[i][0]);
        edge3.index = this.edges.length;
        edge3.nextHalfEdge = edge1.index;
        edge3.originVertex = v3Idx;
        this.edges.push(edge3);
        
        if(this.vertices[v3Idx] == null)
            this.vertices[v3Idx].setOutEdge(this.edges.length-1);
        
       //referencia para a face a qual pertencem. Usado apra calcular normais 
        dataToMesh.vertex_vertex_edge[v1Idx][v2Idx] = edge1.index;
        dataToMesh.vertex_vertex_edge[v2Idx][v3Idx] = edge2.index;
        dataToMesh.vertex_vertex_edge[v3Idx][v1Idx] = edge3.index;   
        
        //face normal. o produto cruzado de dois vetores da face 
        //gera um norma, de 90 graus.
        //p2 - p1
        var e1v1= this.vertices[edge1.originVertex];
        var e1v2= this.vertices[edge1.targetVertex];
        var vec1 = new Vector(e1v2.x-e1v1.x, e1v2.y-e1v1.y,e1v2.z-e1v1.z);
        
        //p3 - p1
        e1v1= this.vertices[edge3.targetVertex];
        e1v2= this.vertices[edge3.originVertex];
        var vec2 = new Vector(e1v2.x-e1v1.x, e1v2.y-e1v1.y,e1v2.z-e1v1.z);
        
        var faceN = vec1.cross(vec2);
        faceN.normalize();
        this.faces[i].normal = faceN;
        
    }
    for(i = 0; i < this.edges.length; i++)
    {
       var oVtx = this.edges[i].originVertex;
       var tVtx = this.edges[i].targetVertex;
       this.edges[i].opositeHalfEdge = dataToMesh.vertex_vertex_edge[tVtx][oVtx];
    }
    
    //calcula as normais de cada vértice = média das normais das faces que 
    //referenciam o vértice
    for(i = 0; i < this.vertexNumber; i++)
    {
        var j;
        var v = new Vector()
        var numFaces = this.vertices[i].faces.length;
        
        for(j = 0; j < numFaces; j++)
        {
            v = v.add(this.faces[this.vertices[i].faces[j]].normal);
        }
       
        v.normalize();
        this.vertices[i].normal = v;
    }
    
    //limpa
    dataToMesh.vertex               = null;
    dataToMesh.vertex_vertex_edge   = null;
    dataToMesh.faces_vertex         = null;
    dataToMesh                      = null;
    
    
    this.createColorBuffer = function()
    {
        var arr = new Array();
        var i;
        for(i = 0; i < this.vertexNumber; i++)
            arr.push(this.vertices[i].color.r,this.vertices[i].color.g, this.vertices[i].color.b );
        
        return arr;
    }
    
    this.createVertexBuffer = function()
    {
        var arr = new Array();
        var i;
        for(i = 0; i < this.vertexNumber; i++)
            arr.push(this.vertices[i].x,this.vertices[i].y, this.vertices[i].z );
        
        return arr;
    }
    
    this.createVertexIndex = function()
    {
        var arr = new Array();
        var i;
        for(i = 0; i < this.faceNumber; i++)
        {
            var f = this.faces[i].edge;
            var j = f;       
            do
            {
                var vtx = this.vertices[this.edges[j].targetVertex];
                arr.push(vtx.index);
                j = this.edges[j].nextHalfEdge;
            }while(j != f);//circula a face
        }
        return arr;
    }
 
    this.createNormalBuffer = function()
    {
        var vtx = 0;
        var arr = new Array();
        for(vtx =0; vtx < this.vertexNumber; vtx++){
            arr.push(this.vertices[vtx].normal.x, this.vertices[vtx].normal.y, this.vertices[vtx].normal.z);
        }
        return arr;
    }

    //vertice com vertice por face.
    this.createPerFaceVertexBuffer = function()
    {
        var arr = new Array();
        var i;
        for(i = 0; i < this.faceNumber; i++)
        {
            var f = this.faces[i].edge;
            var j = f;       
            do
            {
                var vtx = this.vertices[this.edges[j].targetVertex];
                arr.push(vtx.x, vtx.y, vtx.z);
                j = this.edges[j].nextHalfEdge;
            }while(j != f);//circula a face
        }
        return arr;
    }
    
    this.createPerFaceColorBuffer = function()
    {
         var arr = new Array();
        var i;
        for(i = 0; i < this.faceNumber; i++)
        {
            var f = this.faces[i].edge;
            var j = f;       
            do
            {
                var vtx = this.vertices[this.edges[j].targetVertex];
                arr.push(vtx.color.r, vtx.color.g, vtx.color.b);
                j = this.edges[j].nextHalfEdge;
            }while(j != f);//circula a face
        }
        return arr;
    }
     this.createPerFaceNormalBuffer = function()
    {
         var arr = new Array();
        var i;
        for(i = 0; i < this.faceNumber; i++)
        {
            var f = this.faces[i].edge;
            var j = f;       
            do
            {
                var vtx = this.vertices[this.edges[j].targetVertex];
                arr.push(this.faces[i].normal.x, this.faces[i].normal.y, this.faces[i].normal.z);
                j = this.edges[j].nextHalfEdge;
            }while(j != f);//circula a face
        }
        return arr;
    }
}

function Face(edge){
    
    //edge index
    this.edge = edge;
    this.normal = null;
    this.index = 0;
}


function Edge(face, targetVertex){
    
    this.targetVertex = targetVertex;
    this.originVertex = 0;
    this.nextHalfEdge = 0;
    this.opositeHalfEdge = 0;
    this.face = face;
    this.index = 0;
}

//um vértice possui o ponto e pode possuir uma normal associada a ele
function Vertex(x, y, z)
{
    if(x === undefined)
        x = 0;
    
    if(y === undefined)
        y = 0;
    
    if(z === undefined)
        z = 0;
    
    
    this.x = x;
    this.y = y;
    this.z = z;
    this.normal = null;
    this.edge   = null;
    this.faces = new Array(); //armazena as faces as quais o vertice pertence
    this.index = 0;
    this.color = new Color(1,1,1);
    
    
}


//vetor, possui as magnitudes, o metodo para normalizar, 
//e outros métodos úteis
function Vector(x, y, z){
    if(x === undefined)
        x = 0;
    
    if(y === undefined)
        y = 0;
    
    if(z === undefined)
        z = 0;
    
    this.x = x;
    this.y = y;
    this.z = z;
    
    this.add = function(vecTwo)
    {
        var res = new Vector();
        res.x = this.x + vecTwo.x;
        res.y = this.y + vecTwo.y;
        res.z = this.z + vecTwo.z;
        
        return res;
    }
    
    this.sub = function(vecTwo)
    {
        var res = new Vector();
        res.x = this.x - vecTwo.x;
        res.y = this.y - vecTwo.y;
        res.z = this.z - vecTwo.z;
        
        return res;
    }
    this.mult = function(vecTwo)
    {
        var res = new Vector();
        res.x = this.x * vecTwo.x;
        res.y = this.y * vecTwo.y;
        res.z = this.z * vecTwo.z;
        
        return res;
    }
    
    this.cross=function(v2)
    {
        var n = new Vector();
        n.x = this.y * v2.z - this.z * v2.y;
        n.y = this.z * v2.x - this.x * v2.z;
        n.z = this.x * v2.y - this.y * v2.x;
        
        return n;
    }
    
    this.norm = function()
    {
        return Math.sqrt(this.x*this.x + this.y*this.y + this.z*this.z );
    }
    this.normalize = function()
    {
        var norm_ = this.norm();
        if(norm_ == 0)
            return;
        if(this.x !=0)
            this.x = this.x / norm_;
        if(this.y !=0)
            this.y = this.y / norm_;
        if(this.z !=0)
            this.z = this.z / norm_;
        
    }
}


