/* 
    Arquivo do controle do mouse
    Aqui esta o trackball descrito do trabalho
 */
var canvasW, canvasH, arcBallOn = false;
var trackingMouse = false, redrawContinue = false, trackballMove = false;
var lastPos = vec3.fromValues(0,0,0), axis = vec3.create(), trans = vec3.create();

var curx, cury, startX, startY;

var angle = 0; 

var radius = 1.0;

var zoomLastY =0, zoomCurrentY = 0;

var panLastPos = vec2.create(), panCurrentPos = vec2.create();

var eyeXY = vec2.fromValues(0, 0);
var vPos = 2;
function quatToRot(q)
{
  var qX = q[0];
  var qY = q[1];
  var qZ = q[2];
  var qW = q[3];

  var qWqW = qW * qW;
  var qWqX = qW * qX;
  var qWqY = qW * qY;
  var qWqZ = qW * qZ;
  var qXqW = qX * qW;
  var qXqX = qX * qX;
  var qXqY = qX * qY;
  var qXqZ = qX * qZ;
  var qYqW = qY * qW;
  var qYqX = qY * qX;
  var qYqY = qY * qY;
  var qYqZ = qY * qZ;
  var qZqW = qZ * qW;
  var qZqX = qZ * qX;
  var qZqY = qZ * qY;
  var qZqZ = qZ * qZ;

  var d = qWqW + qXqX + qYqY + qZqZ;

  return [
    (qWqW + qXqX - qYqY - qZqZ) / d,
     2 * (qWqZ + qXqY) / d,
     2 * (qXqZ - qWqY) / d, 0,

     2 * (qXqY - qWqZ) / d,
     (qWqW - qXqX + qYqY - qZqZ) / d,
     2 * (qWqX + qYqZ) / d, 0,

     2 * (qWqY + qXqZ) / d,
     2 * (qYqZ - qWqX) / d,
     (qWqW - qXqX - qYqY + qZqZ) / d, 0,

     0, 0, 0, 1];
}
function trackball_ptov(x, y, width, height, v)
{
    
    
    v[0] = radius * x/canvasW*2 - radius;  //-1 -- 1
    v[1] = radius * y /canvasH * 2 -radius;
    v[2] = 0;
  // document.getElementById("debug").innerHTML="canvasw: " + canvasW + "canvasH:" + canvasH + " P: " + vecToStr(p)+ "<br>";
    v[1] = -v[1];
    var tam = v[0] *v[0] + v[1] * v[1];
    if(tam <= radius * radius)
        v[2] = Math.sqrt(radius * radius - tam);
    else
        vec3.normalize(v,v); 
    
    
    
    /*var d, a;
    //ponto na esfera
    
    
    
    v[0] = (2.0 * x - width) / width;
    v[1] = (height - 2.0 * y) / height;
    
    d = Math.sqrt(v[0]*v[0] + v[1]*v[1]);
    
    //v[2] = Math.cos((Math.PI/2.0) * ((d < 1.0) ? d : 1.0));
    
    if(d > 1.0)
        d = 1.0;
    v[2] = Math.cos( (Math.PI/2.0) * d );
    
   
    a = 1.0 / vec3.length(v);
    vec3.scale(v,v,a);*/
    
    
}

function mousePress(event, element)
{
    var x = event.pageX - element.getBoundingClientRect().left;
    //var y = canvasH - event.pageY - element.getBoundingClientRect().top;
    var y = event.pageY - element.getBoundingClientRect().top;
    startMotion(x, y);
    
}

function startMotion(x, y)
{
    
    trackingMouse = true;
    redrawContinue = false; 
    startX = x;
    startY = y;
    curx = x;
    cury = y;
    trackball_ptov(x, y, canvasW, canvasH, lastPos);
    trackballMove = true;
    
}
function mouseMove(event, element)
{
    
        
    var x = event.pageX - element.getBoundingClientRect().left;
    var y = event.pageY - element.getBoundingClientRect().top;
    
    if(zooming)
    {
        zoomCurrentY = y;
        if(zoomCurrentY > zoomLastY)
        {
            vPos+= 0.01;    
        }
        else if(zoomCurrentY < zoomLastY)
            vPos-= 0.01;
        zoomLastY = zoomCurrentY;
        mat4.lookAt(vMatrix,[eyeXY[0],eyeXY[1],vPos], [eyeXY[0],eyeXY[1],0],[0,1,0]);
        return;
    }
    
    if(pan === true)
    {
        panCurrentPos[0] = x;
        panCurrentPos[1] = y;
        if(panCurrentPos[0] !=0 || panCurrentPos[1] != 0)
        {
            var diff = vec2.create();
            vec2.subtract(diff, panCurrentPos,panLastPos);
            vec2.normalize(diff,diff);
            eyeXY[0] += diff[0] * 0.01;
            eyeXY[1] +=-1 * diff[1] * 0.01;
            
           mat4.lookAt(vMatrix,[eyeXY[0],eyeXY[1],vPos], [eyeXY[0],eyeXY[1],0],[0,1,0]);
           
         }
         vec2.copy(panLastPos, panCurrentPos);
         return;
    }
    
    var curPos = vec3.create();
    var dx, dy, dz;
    trackball_ptov(x, y, canvasW, canvasH, curPos);
    if(trackingMouse)
    {
        //TODO: teste
        /*
        var inV = mat4.create();
        mat4.invert(inV, vMatrix);
        curPos[0] = curPos[0] * inV[0] + curPos[1] * inV[1] + curPos[2] * inV[2];
        curPos[1] = curPos[0] * inV[4] + curPos[1] * inV[5] + curPos[2] * inV[6];
        curPos[2] = curPos[0] * inV[8] + curPos[1] * inV[9] + curPos[2] * inV[10];
        
        
        lastPos[0] = lastPos[0] * inV[0] + lastPos[1] * inV[1] + lastPos[2] * inV[2];
        lastPos[1] = lastPos[0] * inV[4] + lastPos[1] * inV[5] + lastPos[2] * inV[6];
        lastPos[2] = lastPos[0] * inV[8] + lastPos[1] * inV[9] + lastPos[2] * inV[10];
        */
        //TODO: FIM Teste
        
        
        dx = curPos[0] - lastPos[0];
        dy = curPos[1] - lastPos[1];
        dz = curPos[2] - lastPos[2];
        
        if (dx || dy || dz) 
        {
         /* compute theta and cross product */
           //angle = 90.0 * Math.sqrt(dx*dx + dy*dy + dz*dz);
           angle = Math.acos(dx*dx + dy*dy + dz*dz);
           vec3.cross(axis, lastPos, curPos);        
            vec3.copy(lastPos, curPos);
         }
             
    }
    
    if(trackballMove)
    {
        var rotQuat = quat.create();
        quat.setAxisAngle(rotQuat, axis, angle);
        var rm = quatToRot(rotQuat);
       // mat4.rotate(vMatrix, vMatrix, angle, axis);
       //mat4.multiply(mMatrix, rm, mMatrix);
       mat4.multiply(mMatrix, rm, mMatrix);
    }
}

function mouseUp(event, element)
{
    var x = event.pageX - element.getBoundingClientRect().left;
    //var y = canvasH - event.pageY - element.getBoundingClientRect().top;
    var y = event.pageY - element.getBoundingClientRect().top;
    stopMotion(x, y);
}

function stopMotion(x, y)
{
    /*if(startX != x || startY != y)
    {
        redrawContinue = true;
    }
    else*/
    {
        angle = 0.0;
        redrawContinue = false;
        trackballMove = false;
        trackingMouse = false;
    }
}




function setCoordinates(element)
{
    
    canvasW = (element.getBoundingClientRect().right - element.getBoundingClientRect().left);
    canvasH = (element.getBoundingClientRect().bottom - element.getBoundingClientRect().top);
}

function zoom(valor)
{
        vPos+= valor;  
        mat4.lookAt(vMatrix,[eyeXY[0],eyeXY[1],vPos], [eyeXY[0],eyeXY[1],0],[0,1,0]);
        return;
}