/* 
 Cada shader é um programa que executa na GPU. Tem o shader de vértice que
altera a posições de cada vértice e os shaders de fragmento, que vão dar a 
coloração final de cada pixel que será renderizado. 

 */

var passTruFrg = 
        "varying highp vec4 vColor;"+
        "void main(void) {" +
            "gl_FragColor = vColor;" +
       "}";

var passTruVtx = 
    "uniform mat4 uPMatrix;" + //matriz de projecao para camera
    "uniform mat4 uMMatrix;" + //matriz de projecao modelo -> mundo
    "uniform mat4 uVMatrix;"+
    "attribute vec3 aVertexPosition;"+ //posicao do vertice
    "attribute vec3 aVertexColor;"+
    "varying highp vec4 vColor;" + //cor do vertice
    "void main(void) {"+
        "gl_Position = uPMatrix * uVMatrix * uMMatrix * vec4(aVertexPosition, 1.0);" +
        "vec3 cor = vec3(1,0,0);"+
        "vColor = vec4(aVertexColor, 1.0);" +
    "}";
    


var phongFrag = 
"varying highp vec3 vColor;"+
"varying highp float diffuseLambert;"+
"varying highp float specular;"+
"void main(void) {"+
"   highp float AmbientIntensity = 0.3;"+
"   highp vec3 DiffuseLightIntensity = vec3(0.9,0.9,0.9);"+
"   highp float SpecularIntensity = 0.5;"+
"   highp vec3 AmbientColour = vec3(0.1, 0.1, 0.1);"+
"   highp vec3 DiffuseMaterialColour = vColor;"+
"   highp vec3 SpecularColour = vec3(1.0, 1.0, 1.0);"+
"   gl_FragColor = vec4(specular,specular,specular,1.0);"+
"   gl_FragColor = vec4(AmbientColour*AmbientIntensity +diffuseLambert * DiffuseMaterialColour*DiffuseLightIntensity +SpecularColour * specular*SpecularIntensity,1.0);"+
"  gl_FragColor.a = 1.0;"+
"}";

var phongVtx = 
"attribute vec3 aVertexPosition;"+
"attribute vec3 aVertexColor;"+
"attribute vec3 aVertexNormal;"+
"mat3 uNormalMatrix;"+
"uniform mat4 uMMatrix;"+
"uniform mat4 uPMatrix;"+
"uniform mat4 uVMatrix;"+
"varying vec3 vColor;"+
"varying float diffuseLambert;"+
"varying float specular;"+
"void main(void) {"+

""+
"       uNormalMatrix = mat3(uVMatrix * uMMatrix);"+
"      gl_Position = uPMatrix * uVMatrix * uMMatrix * vec4(aVertexPosition, 1.0);"+
"      vColor = aVertexColor;"+
"      vec3 pointLightPosition = vec3(3.0, 3.0, 0.0);"+
      
"      pointLightPosition = (vec4(pointLightPosition, 1.0) * uMMatrix).xyz;"+
"      vec3 pointLightDirection = normalize(vec3(pointLightPosition.xyz - aVertexPosition.xyz));"+
       
      //   vec3 pointLightDirection = vec3(0.3,-0.3,0.3);+
"      vec3 L = uNormalMatrix * pointLightDirection;"+
"      vec3 N = normalize(uNormalMatrix * aVertexNormal);"+

"      vec3 V = -vec3(normalize(uVMatrix * vec4(aVertexPosition,1.0)).xyz);"+

"      V = normalize(V);"+
"      L = normalize(L);"+
"      V = normalize(V);"+
"      vec3 R = reflect(-L, N);"+
"      float shininess = 8.0;"+
"      specular = pow( max(0.0, dot(R, V)), shininess);"+
"      diffuseLambert = dot(L, N);"+
"      vColor = aVertexColor; "+

"}";
    
    
var flatFrag = 
"varying highp vec4 vColor;" +
"varying highp vec3 vLight;" +
"void main(void) {" +
"gl_FragColor = vec4(vColor.xyz * vLight, vColor.a);" +
"}";

flatVtx = "attribute vec3 aVertexPosition;"+
"attribute vec3 aVertexColor;"+
"attribute vec3 aVertexNormal;"+
"attribute vec2 aVertexTexCoord;"+
"uniform mat3 uNormalMatrix;"+
"uniform mat4 uMMatrix;"+
"uniform mat4 uPMatrix;"+
"uniform mat4 uVMatrix;"+
"varying highp vec4 vColor;"+
"varying highp vec3 vLight;"+
"void main(void) {"+
"    gl_Position = uPMatrix * uVMatrix *uMMatrix * vec4(aVertexPosition, 1.0);"+
"   vColor = vec4(aVertexColor, 1.0);"+
"   vec3 ambientLight = vec3(0.4, 0.4, 0.4);"+
"   vec3 pointLightPosition = vec3(1.0,2.0,-1.0);"+
"   vec3 pointLightDirection = normalize(vec3(pointLightPosition.xyz - aVertexPosition.xyz));"+
"   vec3 L = vec3(uPMatrix * uMMatrix * vec4(pointLightDirection, 1.0));"+
"   vec3 N = uNormalMatrix * aVertexNormal;"+
"   float diffuseLightAmount = max( dot(normalize(N), normalize(L)), 0.0);"+
"   vLight = ambientLight + vec3(.8,.8,.8) * diffuseLightAmount;"+
"}";


        
